using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net.Mail;

namespace SMTPtest
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void sendButton_Click(object sender, EventArgs e)
        {
            MailAddress eMailFrom;
            MailAddress eMailTo;

            // Adressaten anlegen
            // Das ist hier etwas grob. Besser wre es wenn jede Mailadresse ihren eigenen try/catch htte.

            try
            {
                eMailFrom = new MailAddress(FROMtextBox.Text);
                eMailTo = new MailAddress(TOtextBox.Text);
            }
            catch (FormatException)
            {
                MessageBox.Show("Keine gltige eMail Adresse");
                return;
            }
            catch (ArgumentException)
            {
                MessageBox.Show("eMail Adresse darf nicht leer sein");
                return;
            }

            // Mail Message erzeugen, from und to als Parameter

            MailMessage myMailMessage = new MailMessage(eMailFrom, eMailTo);

            myMailMessage.Subject = SUBJECTtextBox.Text;
            myMailMessage.Body = MESSAGEtextBox.Text;

            // SmtpClient erzeugen, Authentifizierungs Credentials (fr POP3 before SMTP) nicht vergessen.

            SmtpClient mySMTPClient = new SmtpClient("Servername oder IP Adresse");

            mySMTPClient.Credentials = new System.Net.NetworkCredential("Postfach Username", "Postfach Passwort");

            // Ein Delegate fr ein Event, da das ganze Versenden asynchron abluft
            mySMTPClient.SendCompleted += new SendCompletedEventHandler(VersandBeendet);

            string userState = "Test Nachricht";
            mySMTPClient.SendAsync(myMailMessage, userState);
        }
        
        /// <summary>
        /// Event wenn Nachricht gesendet oder abgebrochen
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public static void VersandBeendet(object sender, AsyncCompletedEventArgs e)
        {
            String token = (string)e.UserState;

            MessageBox.Show(token); // Das hier ist wieder unser userState

            if (e.Cancelled)
            {
                MessageBox.Show(token + " Versand abgebrochen");
            }
            if (e.Error != null)
            {
                MessageBox.Show(token + " " + e.Error.ToString());
            }
            else
            {
                MessageBox.Show("Nachricht versendet");
            }
        }
    }
}